﻿Shader "Camp Cult/Rays/ShapeShiftJam" {
	Properties{
		_Color1("Color 1", Color) = (1,1,1,1)
		_Color2("Color 2", Color) = (1,0,0,1)
		_Color3("Color 3", Color) = (1,0,0,1)
		_x("X-smoothing Y-pos Z-warp W-null",Vector) = (.75,1.5,.75,0)
		_Shape("X-spinMul Y-spinBase Z-mul",Vector) = (.75,1.5,.75,0)
		_Fog("Fog",Float) = 10
		_Mouse("Mouse",Vector) = (0,0,0,0)
	}
		Category{
		Blend SrcAlpha OneMinusSrcAlpha
		Tags{ "Queue" = "Transparent" }
		SubShader{
		Pass{
		CGPROGRAM
#include "UnityCG.cginc"
#include "ray.cginc"
#pragma vertex vert_img
#pragma fragment frag
#define count 1.
#define pi 3.14159
		uniform float4 _Color1;
	uniform float4 _Color2;
	uniform float4 _Color3;
	uniform float _Fog;
	uniform float4 _x;
	uniform float4 _Shape;
	uniform float4 _Mouse;

	// Hacked apart by cale bradbury - netgrind.net/2015
	// Based on work by inigo quilez - iq/2013
	// License Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
	// More info here: http://www.iquilezles.org/www/articles/distfunctions/distfunctions.htm
	float3 threeGradient(float3 low, float3 med, float3 high, float m) {
		return lerp(low, lerp(high, med, min(m*2., 1.)), min((1. - m)*2., 1.));
	}

	float fr(float3 p, float v) {
		return sdBox(p,v.rrr);
	}

	float2 map(in float3 pos)
	{
		float space = 1.;// _Shape.y;
		float size = .05;// _Shape.z + sin(length(pos)*.2 - _Time.y*pi*2. + pos.x*.2)*.1 + .1;
		float2 res = float2(pos.y>-100.,1.1);//float2( pos.y+.2+sin(pos.x*sin(1.+pos.x*4.+pos.z*3.)+cos(pos.z*2.+_Time.y*3.141*2.0)+_Time.y*3.141*2.0)*.03, 0. );	

		float3 p = pos;

		float a = atan2(p.y, p.x) + (pos.z + _x.y)*_Shape.x + _Shape.y;
		float d = length(p.xy);
		d -= sin((p.z + _x.y)*2.)*_Mouse.y;
		p.xy = float2(cos(a)*d, sin(a)*d);

		p.xy *= sin(p.z*pi)*_x.w + 1.;
		p.z = fmod(abs(p.z), space) - space*.5;
		p.x = fmod(abs(p.x),space) - space*.5;
		p.y = fmod(abs(p.y),space) - space*.5;

		size += sin(length(pos.xy)*30. + _Time.y*3.1415)*_Mouse.x*.05+.05;

		float vert = sdBox(float3(p.x,0.0,p.z),float3(size,size,_Shape.z));
		float hori = sdBox(float3(0., p.y, p.z), float3(size, size, _Shape.w));
		float dept = fr(float3(p.x,p.y,0.0),size);

		float2 s = float2( smin3(vert, hori, dept, _x.x), 1.);

		float v = _Mouse.w*(_Mouse.x*.4+.6);
		float b = sdBox(float3(0, 0, abs(fmod(pos.z, v) - v*.5)), float3(.1, .1, .1));
		b = opU(b, sdBox(float3(0, abs(fmod(length(p.xy), v) - v*.5),0.), float3(.1, .1, .1)));

		s.x = lerp(s.x, opS(s.x, b), _Shape.y);

		res = s;// opU(res, s);
		return res;
	}

	float2 castRay(in float3 ro, in float3 rd)
	{
		float tmin = 0.1;
		float tmax = 110.0;

#if 0
		float tp1 = (0.0 - ro.y) / rd.y; if (tp1>0.0) tmax = min(tmax, tp1);
		float tp2 = (1.6 - ro.y) / rd.y; if (tp2>0.0) {
			if (ro.y>1.6) tmin = max(tmin, tp2);
			else           tmax = min(tmax, tp2);
		}
#endif

		float precis = 0.000001;
		float t = tmin;
		float m = -1.0;
		//float3 glitch = float3(0.,0.,0.);
		for (int i = 0; i<100; i++)
		{
			float2 res = map(ro + rd*t);
			
			t += res.x;
			m = res.y;
			
		}

		return float2(t, m);
	}


	float calcAO(in float3 pos, in float3 nor)
	{
		float occ = 0.0;
		float sca = 1.0;
		for (int i = 0; i<5; i++)
		{
			float hr = 0.01 + 0.12*float(i) / 4.0;
			float3 aopos = nor * hr + pos;
			float dd = map(aopos).x;
			occ += -(dd - hr)*sca;
			sca *= 0.95;
		}
		return clamp(1.0 - 3.0*occ, 0.0, 1.0);
	}
	float3 calcNormal(in float3 pos)
	{
		float3 eps = float3(0.1, 0.0,0.0);
		float3 nor = float3(
			map(pos + eps.xyy).x - map(pos - eps.xyy).x,
			map(pos + eps.yxy).x - map(pos - eps.yxy).x,
			map(pos + eps.yyx).x - map(pos - eps.yyx).x);
		return normalize(nor);
	}

	float softshadow(in float3 ro, in float3 rd, in float mint, in float tmax)
	{
		float res = 1.0;
		float t = mint;
		for (int i = 0; i<16; i++)
		{
			float h = map(ro + rd*t).x;
			res = min(res, 8.0*h / t);
			t += clamp(h, 0.02, 0.10);
			if (h<0.0001 || t>tmax) break;
		}
		return clamp(res, 0.0, 1.0);

	}

	float3 render(in float3 ro, in float3 rd)
	{
		float3 col = float3(1.0,1.0, 1.0);
		float2 res = castRay(ro,rd);
		float t = res.x;
		float m = res.y;

		float3 pos = ro + t*rd;
		float3 nor = calcNormal(pos);
		float3 ref = reflect( rd, nor );

		// material        
		col = float3(.5,.5,.5);

		float occ = calcAO(pos, nor);
		float3  lig = normalize(float3(1,1,0));
		float amb = clamp(0.5 + 0.5*nor.y, 0.0, 1.0);
		float dif = clamp(dot(nor, lig), 0.0, 1.0);
		float bac = clamp(dot(nor, normalize(float3(-lig.x, 0.0, -lig.z))), 0.0, 1.0)*clamp(1.0 - pos.y, 0.0, 1.0);
		float fre = pow(clamp(1.0 + dot(nor, rd), 0.0, 1.0), 2.0);

		dif *= softshadow(pos, lig, 0.02, 2.5);

		float3 brdf = (0.0);
		brdf += 1.20*dif*(1.00);
		brdf += 0.30*amb*(0.50)*occ;
		brdf += 0.30*bac*(.25)*occ;
		brdf += 1.40*fre*(1.00)*occ;
		col = col*brdf;
		col *= pow(saturate(1.0- t*.15),2.);

		//col*=pow(1.0-res.x*.01,8.);
		return float3(clamp(col,0.0,1.0));
	}

	float3x3 setCamera(in float3 ro, in float3 ta, float cr)
	{
		float3 cw = normalize(ta - ro);
		float3 cp = float3(sin(cr), cos(cr),0.0);
		float3 cu = normalize(cross(cw,cp));
		float3 cv = normalize(cross(cu,cw));
		return float3x3(cu, cv, cw);
	}

	fixed4 frag(v2f_img i) : COLOR
	{
		float2 q = i.uv;
		float2 p = -1.0 + 2.0*q;
		float time = _Time.y;

		// camera	
		float3 ro = float3(0.0,0.,-_x.y);
		float3 ta = ro+float3(0, 0., 1.);

		// camera-to-world transformation
		float3x3 ca = setCamera(ro, ta, 0.0);
		// ray direction
		float velocity = _x.z;

		float fov = 100.0;
		float mu = 500.;
		float rayZ = tan((90.0 - 0.5 * fov) * 0.01745329252);
		float3 rd = mul(normalize(float3(p.xy,-rayZ)*mu),ca);
		rd = float3(rd.xy,rsqrt(1.0 - velocity * velocity) * (rd.z + velocity));
		rd = normalize(rd);


		// render	
		float3 col = float3(0.,0.,0.);

		col = render(ro, rd );
		
		col = pow(col, float(0.4545).rrr);
		col = threeGradient(_Color1.rgb, _Color2.rgb, _Color3.rgb, col.r);
		col *= saturate(((1-length(p)*.5)*_Mouse.z*2));
		return  float4(col, _Fog);
	}
		ENDCG
	}
	}
	}
		FallBack "Unlit"
}
